"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger

 New code and modifications done at SWING Research Group [1]:

 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 [1] Code written at SWING Research Group contains a signature
     of one of the above copright owners. For exact set of such code,
     see the differences between this version and version stx:libjava
     as of 1.9.2010
"
"{ Package: 'stx:libjava' }"

Object subclass:#JavaEvaluator
	instanceVariableNames:''
	classVariableNames:'WorkspaceBinding'
	poolDictionaries:''
	category:'Languages-Java-Support'
!

!JavaEvaluator class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger

 New code and modifications done at SWING Research Group [1]:

 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 [1] Code written at SWING Research Group contains a signature
     of one of the above copright owners. For exact set of such code,
     see the differences between this version and version stx:libjava
     as of 1.9.2010

"
! !

!JavaEvaluator class methodsFor:'utilities'!

flushWorkspaceBinding

    WorkspaceBinding := nil

    "Created: / 02-12-2011 / 23:23:48 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!JavaEvaluator methodsFor:'compiler interface'!

evaluate:source 

    ^self evaluate:source in: nil receiver: nil notifying: nil logged: false ifFail: [self error:'Evaluation failed'].

    "Created: / 02-09-2011 / 10:24:46 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

evaluate: source in: context receiver: receiver notifying: requestor logged: logged ifFail: fail 
    | binding  shell  result |

    JavaVM booted ifFalse: [
        Java initialize.
        JavaVM initializeVM.
    ].
    (requestor notNil and: [ requestor application isKindOf: WorkspaceApplication ]) ifTrue: [
        WorkspaceBinding isNil ifTrue: [
            WorkspaceBinding := (JavaVM classForName: 'groovy.lang.Binding') new.
        ].
        binding := WorkspaceBinding
    ] ifFalse: [ 
        binding := (Java classForName: 'groovy.lang.Binding') new. 
    ].

    shell := (Java classForName: 'groovy.lang.GroovyShell') newCleared.
    shell perform: #'<init>(Lgroovy/lang/Binding;)V' with: binding.
    result := shell perform: #'evaluate(Ljava/lang/String;)Ljava/lang/Object;'
                with: (Java 
                        as_String: (source isText ifTrue: [ source string ] ifFalse: [ source ])).
    ^ self unbox: result.

    "Created: / 17-08-2011 / 08:54:23 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

moreSharedPools: pools

    "Ignored for Java"

    "Created: / 16-08-2011 / 10:15:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!JavaEvaluator methodsFor:'private'!

unbox: anObject

    | nm |
    nm := anObject class name.

    nm == #'java/lang/Byte' ifTrue:[
        ^anObject instVarNamed: #value.
    ].
    nm == #'java/lang/Short' ifTrue:[
        ^anObject instVarNamed: #value.    
    ].
    nm == #'java/lang/Integer' ifTrue:[
        ^anObject instVarNamed: #value.
    ].
    nm == #'java/lang/Long' ifTrue:[
        ^anObject instVarNamed: #value.
    ].
    nm == #'java/lang/Character' ifTrue:[
        ^Character codePoint: (anObject instVarNamed: #value).
    ].
    nm == #'java/lang/Boolean' ifTrue:[
        ^ (anObject instVarNamed: #value) == 1
    ].
    nm == #'java/lang/String' ifTrue:[
        ^ Java as_ST_String: anObject.
    ].

    ^anObject

    "Created: / 01-12-2011 / 23:47:24 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!JavaEvaluator class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
