"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger

 New code and modifications done at SWING Research Group [1]:

 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 [1] Code written at SWING Research Group contains a signature
     of one of the above copright owners. For exact set of such code,
     see the differences between this version and version stx:libjava
     as of 1.9.2010
"
"{ Package: 'stx:libjava' }"

JavaParserTestCase subclass:#JavaParserNavigationTests
	instanceVariableNames:'result'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Tests'
!

!JavaParserNavigationTests class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger

 New code and modifications done at SWING Research Group [1]:

 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 [1] Code written at SWING Research Group contains a signature
     of one of the above copright owners. For exact set of such code,
     see the differences between this version and version stx:libjava
     as of 1.9.2010

"
! !

!JavaParserNavigationTests methodsFor:'accessing'!

firstMethod
    ^ self methods first

    "Created: / 29-12-2010 / 21:05:13 / Jan Kurs <kurs.jan@post.cz>"
!

methods
    ^ self result methods.

    "Created: / 29-12-2010 / 21:05:11 / Jan Kurs <kurs.jan@post.cz>"
    "Modified: / 08-01-2011 / 16:07:17 / Jan Kurs <kurs.jan@post.cz>"
!

result
    ^ result
!

result:something
    result := something.
!

secondMethod
    ^ self methods second

    "Created: / 30-12-2010 / 11:01:21 / Jan Kurs <kurs.jan@post.cz>"
!

thirdMethod
    ^ self methods third

    "Created: / 30-12-2010 / 11:01:47 / Jan Kurs <kurs.jan@post.cz>"
! !

!JavaParserNavigationTests methodsFor:'testing'!

testConstructor
    self parse: '
public class Foo
{
    private Foo() {
    }
}
'.                
    self assert: (self methods size = 1).
    self assert: (self firstMethod startLine = 4).

    "Created: / 08-01-2011 / 16:25:18 / Jan Kurs <kurs.jan@post.cz>"
!

testConstructor2
    self parse: '
public class Foo
{
    private Foo() {
    }

    public Foo(O o) {}
}
'.                
    self assert: (self methods size = 2).
    self assert: (self firstMethod startLine = 4).
    self assert: (self secondMethod startLine = 7).

    "Created: / 08-01-2011 / 16:25:57 / Jan Kurs <kurs.jan@post.cz>"
!

testFoo
    self parse: '
public class Foo
{
    public void foo() {}
}
'.                
    self assert: (self methods size = 1).
    self assert: (self firstMethod startLine = 4).

    "Created: / 29-12-2010 / 21:05:13 / Jan Kurs <kurs.jan@post.cz>"
!

testMethod
    self parse: '
public class Foo
{
    // some comment
    public void foo() {
    }
}
'.                
    self assert: (self methods size = 1).
    self assert: (self firstMethod startLine = 5).

    "Created: / 30-12-2010 / 10:59:37 / Jan Kurs <kurs.jan@post.cz>"
!

testMethodJavadoc
    self parse: '
public class Foo
{
    // some comment
    /**
     *  This is javadoc
     */
    public void foo() {
    }
}
'.                
    self assert: (self methods size = 1).
    self assert: (self firstMethod startLine = 5).

    "Created: / 30-12-2010 / 11:00:18 / Jan Kurs <kurs.jan@post.cz>"
!

testMethodJavadoc2
    self parse: '
public class Foo
{
    // some comment
    /** javadoc */
    /**
     *  This is javadoc
     */
    public void foo() {
    }
}
'.                
    self assert: (self methods size = 1).
    self assert: (self firstMethod startLine = 6).

    "Created: / 30-12-2010 / 11:00:29 / Jan Kurs <kurs.jan@post.cz>"
!

testMultipleMethods
    self parse: '
public class Foo
{
    public void foo() {
    }

    abstract void foo2()
}
'.                
    self assert: (self methods size = 2).
    self assert: (self firstMethod startLine = 4).
    self assert: (self secondMethod startLine = 7).

    "Created: / 30-12-2010 / 11:00:37 / Jan Kurs <kurs.jan@post.cz>"
! !

!JavaParserNavigationTests methodsFor:'utilities'!

parse: string
    self result: (super parse: string).
    ^ self result.

    "Modified: / 29-12-2010 / 21:07:06 / Jan Kurs <kurs.jan@post.cz>"
! !

!JavaParserNavigationTests class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
