"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:libjava/experiments' }"

Lookup subclass:#SmalltalkLookup
	instanceVariableNames:''
	classVariableNames:'Instance'
	poolDictionaries:''
	category:'Languages-Java-Experiments-Lookup'
!

!SmalltalkLookup class methodsFor:'documentation'!

copyright
"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

"
! !

!SmalltalkLookup class methodsFor:'instance creation'!

instance
    self halt: 'obsolete?'.
    Instance ifNil: [
        Instance := self basicNew initialize
    ].
    ^ Instance

    "Modified: / 25-09-2011 / 22:24:07 / Jan Kurs <kursjan@fit.cvut.cz>"
    "Modified: / 23-12-2011 / 18:33:49 / kursjan <kursjan@fit.cvut.cz>"
!

new
    ^ self shouldNeverBeSent.

    "Modified: / 25-09-2011 / 22:24:14 / Jan Kurs <kursjan@fit.cvut.cz>"
! !

!SmalltalkLookup class methodsFor:'lookup'!

cleanInstance
    ^ Instance := nil.

    "Created: / 28-09-2011 / 12:33:09 / Jan Kurs <kursjan@fit.cvut.cz>"
! !

!SmalltalkLookup methodsFor:'lookup'!

lookupMethodForSelector:selector directedTo:initialSearchClass for:aReceiver withArguments:argArrayOrNil from:sendingContext ilc: ilc
    | m jm sm cls |
    "perform standard lookup"
    m := super lookupMethodForSelector:selector directedTo:initialSearchClass for:aReceiver withArguments:argArrayOrNil from:sendingContext ilc: ilc.
    m notNil ifTrue: [ ^ m ].

    "nothing found? Maybe selector is JavaSelector"
    (selector includes: $() ifFalse:[
        "Hmm, not a Java selector..."
        ^nil.
    ].
    jm := self descriptorForJavaSelector: selector.

    sm := (JavaTypeBox typeBoxForSmalltalkClass: initialSearchClass) javaMessageToSmalltalk: jm.
    sm notNil ifTrue: [ ^ sm ].

    cls := initialSearchClass.
    [ cls notNil ] whileTrue:[
        cls selectorsAndMethodsDo: [:s :m || sm |
            sm := self descriptorForSmalltalkSelector: s.
            "find methods with same name and either static or non-static"
            ((sm name = jm name) and: [sm argSize = jm argSize]) ifTrue: [
                self error:'lookupMethod... MUST return method or nil, NOTHING else!!!!!!!!'.
                ^ sm 
                    returnType: jm returnType;
                    yourself.
                "/^m.
            ]                
        ].
        cls := cls superclass.
    ].
    ^ nil.

    "Created: / 06-09-2011 / 22:04:04 / Jan Kurs <kursjan@fit.cvut.cz>"
    "Modified: / 09-10-2011 / 22:59:18 / kursjan <kursjan@fit.cvut.cz>"
    "Created: / 19-11-2011 / 12:37:26 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SmalltalkLookup class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
