package stx.libjava.tests;

import static org.junit.Assert.fail;
import static org.junit.Assert.*;

import org.apache.catalina.startup.Bootstrap;
import org.junit.Test;

import org.apache.catalina.startup.Catalina;

public class StartAndStopTomcatTests {

	private static String TOMCAT = null;
	
	static {
		String tomcat = System.getProperty("stx.libjava.tomcat.dir");
		if (tomcat == null) {
			//CHANGE HERE
			TOMCAT = "/home/jv/Projects/libjava/libs/tomcat/tomcat-6.0.28-src";
		} else {
			TOMCAT = tomcat;
		}
	}
	
	public StartAndStopTomcatTests() {

		System.setProperty("java.util.logging.config.file", TOMCAT + "/conf/logging.properties");
		System.setProperty("java.util.logging.manager", "org.apache.juli.ClassLoaderLogManager");
		System.setProperty("java.endorsed.dirs", TOMCAT + "/endorsed");
		System.setProperty("catalina.base", TOMCAT);
		System.setProperty("catalina.home", TOMCAT);
		System.setProperty("java.io.tmpdir", TOMCAT + "/temp");
		

		// Bootstrap.main(new String[0]);
	}

	public void runTomcat() throws Exception {		
		Bootstrap.main(new String[] { "start" });		
	}

	public void stopTomcat() throws Exception {
		Bootstrap.main(new String[] { "stop" });
	}

	//@Test
	public void testRunningANdStoppingTomcat() throws Exception {
		runTomcat();
		stopTomcat();

	}
	
	//@Test
	public void testRunningTomcat() throws Exception {
		runTomcat();		
	}
	
	@Test
	public void testStoppingTomcat() throws Exception {		
		stopTomcat();
	}

	public static void main(String[] args) throws Exception {
		new StartAndStopTomcatTests().runTomcat();		
	}
}
